commit 7df66a0c95a6b3678c73385969c1395a8aab2bd6
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Fri Aug 27 11:59:54 2021

    libstdc++: Fix inefficiency in filesystem::absolute [PR99876]
    
    When the path is already absolute, the call to current_path() is
    wasteful, because operator/ will ignore the left operand anyway.
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/99876
            * src/c++17/fs_ops.cc (fs::absolute): Call non-throwing form,
            to avoid unnecessary current_path() call.
    
    (cherry picked from commit 07b990ee23e0c7a92d362dbb25fd5d57d95eb8be)

diff --git a/libstdc++-v3/src/c++17/fs_ops.cc b/libstdc++-v3/src/c++17/fs_ops.cc
index ceaf0291d64..acff0ff926e 100644
--- a/libstdc++-v3/src/c++17/fs_ops.cc
+++ b/libstdc++-v3/src/c++17/fs_ops.cc
@@ -65,19 +65,12 @@ namespace posix = std::filesystem::__gnu_posix;
 fs::path
 fs::absolute(const path& p)
 {
-#ifdef _GLIBCXX_FILESYSTEM_IS_WINDOWS
   error_code ec;
   path ret = absolute(p, ec);
   if (ec)
     _GLIBCXX_THROW_OR_ABORT(filesystem_error("cannot make absolute path", p,
 					     ec));
   return ret;
-#else
-  if (p.empty())
-    _GLIBCXX_THROW_OR_ABORT(filesystem_error("cannot make absolute path", p,
-	  make_error_code(std::errc::invalid_argument)));
-  return current_path() / p;
-#endif
 }
 
 fs::path

